import processing.sound.*;

PImage me;
PImage me2;
PImage meteors;
AudioIn mic;
Amplitude analyzer;
FFT fft;
float[] spectrum;
float volume = 0.0;
float scaleSize = 0.0;
int f = 0;   //these                        |
int f2 = 0;  //are                          |
int f3 = 0;  //for the faux portrait's text |
boolean isLow = false;

static final float MAGIC_MIC_NUMBER = 0.0035; //the mic pics up noise and this number helps filter that out
static final int BANDS = 512; //the amount of frequency bands
static final int MAX_PITCH = 5; //the highest frequency band before the faux portrait is made instead

void setup()
{ 
  //size(800, 800);
  fullScreen();
  background(0);
  me = new PImage(width, height);
  fft = new FFT(this, BANDS);
  spectrum = new float[BANDS];
  mic = new AudioIn(this, 0); //start mic, grab 1st channel
  
  mic.start(); //start taking the audio input
  analyzer = new Amplitude(this);
  analyzer.input(mic);
  
  //Let fft have the audio input too
  fft.input(mic);
  
  me = loadImage("face.png"); //faux portrait
  me2 = loadImage("face2.png"); //true portrait
  meteors = loadImage("meteors.png"); //well... they're meteors
  
}



void draw()
{
  
  isLow = false;
  fft.analyze(spectrum); //analyze the mic's sound amongst frequencies 
  volume = analyzer.analyze(); //between 0 and 1.0
  scaleSize = map(volume, 0, 1, 0.01, width*height/100);

  if(volume > MAGIC_MIC_NUMBER + MAGIC_MIC_NUMBER/1.2){//You have to be loud to make a white screen
    strokeWeight(scaleSize); //the white is made with respect to how loud you are
    stroke(255);
    noFill();
    rect(0, 0,  width, height);
  }//NOTE: The white is stacked first so that the black pictures and text can appear visible over it
  
  for(int i = 0; i < BANDS; ++i){//for loop for frequency analyzing 
    
    //println(spectrum[i], i);
    if(spectrum[i] > 0.0075 && i <= MAX_PITCH){
      isLow = true; //is true when there's a notable (loudish) low sound
    }
    if(i > MAX_PITCH){//if statement to see if the loudest sound is low enough
      float max = spectrum[0];
      for(int x = 0; x <= MAX_PITCH; ++x){//for loop to find max volume for low range frequencies
        if(max < spectrum[x]){//find the loudest low pitch
            max = spectrum[x];
        }
      }//end of for loop to find max volume for the low range frequencies
        if(max < spectrum[i]){
            isLow = false; //if a higher frequency is louder than the loudest low frequency, then the sound isn't "truly low"
        }
      }//end of if statement to see if the loudest sound is low enough
  }//end of for loop for frequency analyzing 
  if(isLow){//in the case where the pitch is low enough, you get the true portrait
    image(me2, width - me2.width, height - me2.height); 
    image(meteors, meteors.width + cos(millis())*2, 0);
    image(meteors, cos(millis())*2, 0);
    textSize(12);
    fill(0);
    text("Words are less scary than this.", width/2, height/2);
  }else{//in the case where the pitch is not low enough, you get the faux portrait
    image(me, width - me.width, height - me.height);
    //below makes mean moving text!
    textSize(24);
    fill(0,f);
    text("Wrong",width/4+f+f/2,height/2);
    fill(0,f2);
    text("You're a failure",width/6+f2,height/4);
    fill(0,f);
    text("You'll never amount to anything",f,height/1.5);
    fill(0,f2);
    text("I hate you",1+f2,height/1.75);
    fill(0,f);
    text("Why are you talking to me?",5+f,height/6);
    fill(0,f2);
    text("Shut up",10+f2,height/1.05);
    fill(0,f3);
    text("Scream as loud as you want, fool", 20+f3, height/12);
    fill(0,f3);
    text("You're annoying", width/5+f3, height/3);
    f += 5;
    f2 += 4;
    f3 += 2;
    if(f > width){f = 0;}
    if(f2 > width){f2 = 0;}
    if(f3 > width){f3 = 0;}
  }
  
  //below makes a black screen that slowly fades in
  noStroke();
  fill(0,20); 
  rect(0, 0, width, height);  
  if(volume < MAGIC_MIC_NUMBER){//if it's really quiet, the black will appear faster
    noStroke();
    fill(0,50); 
    rect(0, 0, width, height);  
  }//Ultimately, you have to keep making noise to stop the black from covering everything
  
  //println(volume);
  
  
}
